if (!window.console) window.console = {};
if (!window.console.log) window.console.log = function () { };

// Default settin
var HTMLPopupUrl = "about:blank";
var HTMLPopupWidth = "80%";
var HTMLPopupHeight = "80%";
var ServerAddress = "";
var LiveAddress = "";

// Media name 
var mediaName = "";

function ajaxPopup( url, data, width, height, hide, _settings )
{
    settings = {
        'width'				: width,
        'height'			: height,
        'afterClose'			: closePopup,
        'overlayShow':false,
        'autoSize':true,
        'autoDimensions'    : false,
        'margin':100,
        'helpers' : {
            overlay : {
                css : {
                    'background' : 'rgba(0, 0, 0, 0)'
                }
            }
        }
    };
    if ( _settings!=null )
    {
        for( var p in _settings )
            settings[p] = _settings[p];
    }

    $.ajax({
        url: url,
        type: 'POST',
        dataType: 'html',
        data: data,
        success: function(data, textStatus, xhr) {

            settings.content = data
            $.fancybox( settings );
        },
        error: function(xhr, textStatus, errorThrown) {
            alert("An error occurred.");
            closePopup()
        }
    });

    if ( $('#flashobj')[0]!=null )
    {
        if ( $('#flashobj')[0].enableNxtbook )
            $('#flashobj')[0].enableNxtbook( false );
        if ( hide==true )
            $('#flashobj').css('visibility', 'hidden');
    }
}

function postPopup( url, data, width, height, hide, _settings )
{
    if ( _settings==null )
        _settings = {}

    _settings.afterLoad = function() {

        var f = $('<form class="cloneform" method="post" action="' + url + '" target="fancybox-myFancyboxFrame" style="display:none;"></form>'),
            html = "";
        for ( var p in data )
            html += '<input type="hidden" name="' +p + '" value="' + data[p] + '" />';
        f.html( html );
        $("body").append( f );
        f.submit();

    };
    _settings.tpl = {
        iframe   : '<iframe id="fancybox-myFancyboxFrame" name="fancybox-myFancyboxFrame" class="fancybox-iframe" frameborder="0" vspace="0" hspace="0"' + ($.browser.msie ? ' allowtransparency="true"' : '') + '></iframe>'
    }
    showPopup( "about:blank", width, height, hide, _settings );
}

// Webwindow open
function showPopup( url, width, height, hide, _settings )
{
    // Defautl popup size
    if ( url === null || url === "" )
            url = HTMLPopupUrl;
    if ( width === null || width === "" || typeof(width) == 'undefined' )
            width = HTMLPopupWidth;
    if ( height === null || height === "" || typeof(height) == 'undefined')
            height = HTMLPopupHeight;

    // If target is src/docs that add the server address
    if ( ServerAddress!=="" && url.substr(0,8)==="src/docs" )
        url = ServerAddress + url;

    // Get the file extension, set the type, and adjust auto width if necessary
    var ext = url.toLowerCase().split('.').pop().split(/\#|\?/)[0],
        fbtype = "iframe";

    if ( ext === "jpg" || ext === "jpeg" || ext === "png" || ext === "gif" || ext === "bmp" ) {
        fbtype = "image";
    } else {
        if(width === "auto")
            width = HTMLPopupWidth;
        if(height === "auto")
            height = HTMLPopupHeight;
    }

    // Only accept number or percent values
    if ( typeof width === "string" && width !== "auto" )
    {
        width = width.replace( " ", "" );
        if ( width.substr(width.length-1)!=="%" )
        {
            width = parseInt( width );
            if ( isNaN( width ) )
                width = "100%";
        }
    }

    if ( typeof height === "string" && height !== "auto" )
    {
        height = height.replace( " ", "" );
        if ( height.substr(height.length-1)!=="%" )
        {
            height = parseInt( height );
            if ( isNaN( height ) )
                height = "100%";
        }
    }

    settings = {
        'href'          : url,
        'type'          : fbtype,
        'scrolling'     : 'auto',
        'preload'       : false,
        'width'		: width,
        'height'	: height,
        'minWidth'  : 25,
        'minHeight' : 25,
        'afterClose'	: closePopup,
        'overlayShow'   : false,
        'padding'       : 0,
        'helpers'       : {
                            overlay : {
                                css : {
                                    'background' : 'rgba(0, 0, 0, 0)'
                                }
                            }
        }
    };
    
    if ( fbtype === "iframe" ){
        settings['iframe'] = { 'preload': false };
    }
        

    if ( _settings!==null )
    {
        for( var p in _settings )
            settings[p] = _settings[p];
    }

    console.log( settings );

    $.fancybox( settings ); //{ href: url, type:'iframe', width:width, height:height, scrolling:'yes', preload: false } );
	
	if ( !settings.enableBackground && $('#flashobj')[0]!==undefined )
	{
        if ( $('#flashobj')[0].enableNxtbook )
            $('#flashobj')[0].enableNxtbook( false );
        if ( hide===true )
            $('#flashobj').css('visibility', 'hidden');
	}

}

// Webwindow close
function closePopup() 
{
    $(".cloneform").remove();
    if ( $('#flashobj')[0]!==undefined )
	{
		if ( $('#flashobj')[0].enableNxtbook )
		{
			$('#flashobj')[0].enableNxtbook( true );
			$('#flashobj')[0].focus();
		}
        $('#flashobj').css('visibility', 'visible');
	
        // If mediaName is set, send an extra close event 
        if( mediaName!=="" )
    	{
    		var trackingEventInfo = new Object;
    		trackingEventInfo.eventName = "close";
    		trackingEventInfo.mediaName = mediaName;
    		setTrackingEvent(trackingEventInfo);
    	}
    }
}

// Collect tracking information from the engine
function getTrackingInfo()
{
    try {
        return $('#flashobj')[0].getTrackingInfo( );
    }
    catch(e)
    {}
    return null;
}

// Send trackng event to the engine
function setTrackingEvent( trackObject )
{
    try {
//        console.log( trackObject )
        return $('#flashobj')[0].setTrackingEvent( trackObject );
    }
    catch(e)
    {}
	return false;
}

// Reload the engine configuration
function reloadConfig()
{
	try {
		$('#flashobj')[0].reloadConfig();
    }
    catch(e)
    {}
}

// Show DRM
var parentInterface = null,
    childInterface = null;
function showDRMLogin()
{
    var args = arguments,
        data = null,
        id = "";

    if ( args.length>0 )
        data = args[0];

    if ( data && data.id.indexOf("__NXT__")===0 )
        data.id = data.id.substr(7);

    if ( $("#drmloginframe").length==1 )
    {
        if ( childInterface )
        {
            childInterface.resetDrmForm( data );
        }
        else
        {
            var drmForm = $("#drmloginframe")[0].contentWindow.$.drmForm;
            drmForm.reset.apply( drmForm, args )
        }
        return;
    }

    var settings = {
            autoSize: false,
            fitToView: true,
            closeBtn: false,
            padding: 0,
            margin:0,
            'iframe' : {
                scrolling : 'auto',
                preload   : true
            },
            tpl: {
                wrap     : '<div class="fancybox-wrap" tabIndex="-1"><div style="position: relative; background: none transparent;"><div class="fancybox-outer"><div class="fancybox-inner"></div></div></div></div>',
                iframe   : '<iframe id="drmloginframe" name="drmloginframe" class="fancybox-iframe" frameborder="0" vspace="0" hspace="0" allowtransparency="true"></iframe>'
            },
            enableBackground: true
        },
        url = "/fx/drm/login/index.php?data="+JSON.stringify(data);

    if ( parentInterface )
    {
        settings.afterDomInit = function() { handleDomInit( "drmloginframe" ) };
        settings.afterLoad = function() { handleOnLoad( "drmloginframe" ) };
        url += "&nopr=1";
    }
    showPopup( LiveAddress + url, '100%', '100%', false, settings );
}
function closeDRMLogin()
{
    $.fancybox.close();
}